Package org.mariadb.jdbc.plugin

# Interface AuthenticationPlugin

All Known Implementing Classes:
  `CachingSha2PasswordPlugin`, `ClearPasswordPlugin`, `Ed25519PasswordPlugin`, `NativePasswordPlugin`, `ParsecPasswordPlugin`, `SendGssApiAuthPacket`, `SendPamAuthPacket`

public interface AuthenticationPlugin
Authentication plugin descriptor

## Method Summary

Modifier and Type
Method
Description
`default byte[]`
`hash(Credential credential)`
Return Hash
`default boolean`
`isMitMProof()`
Can plugins is MitM-proof, permitting returning HASH
`org.mariadb.jdbc.client.ReadableByteBuf`
`process(Writer encoder, Reader decoder, org.mariadb.jdbc.client.Context context)`
Process plugin authentication.

## Method Details

### process

org.mariadb.jdbc.client.ReadableByteBuf process(Writer encoder, Reader decoder, org.mariadb.jdbc.client.Context context) throws IOException, SQLException
Process plugin authentication.

Parameters:
  `encoder` - out stream
  `decoder` - in stream
  `context` - connection context
Returns:
  response packet
Throws:
  `IOException` - if socket error
  `SQLException` - if plugin exception

### isMitMProof

default boolean isMitMProof()
Can plugins is MitM-proof, permitting returning HASH

Returns:
  true if permitted

### hash

default byte[] hash(Credential credential)
Return Hash

Parameters:
  `credential` - credential
Returns:
  hash